theory BasicSyntax
imports Main
begin

(*
If everyone who lies also steals, and there is someone who lies,
then there is somene who steals.
*)
lemma
  "(\<forall> x. lies x \<longrightarrow> steals x) \<and> 
   (\<exists> x. lies x) \<longrightarrow> 
   (\<exists> x. steals x)"
  by auto

lemma 
  "\<lbrakk>\<forall> x. lies x \<longrightarrow> steals x; \<exists> x. lies x\<rbrakk> \<Longrightarrow> \<exists> x. steals x"
  by auto

lemma
  assumes "\<forall> x. lies x \<longrightarrow> steals x" 
          "\<exists> x. lies x"
    shows "\<exists> x. steals x"
  using assms
  by auto

(*
If no homework is fun, and some reading is homework, then
some reading is not fun.
*)
lemma
  assumes "\<nexists> x. homework x \<and> fun x"
          "\<exists> x. reading x \<and> homework x"
    shows "\<exists> x. homework x \<and> \<not> fun x"
  using assms
  by auto

(* If there is a shoe that fits every leg, then for every leg
there is a shoe that fits it. Does the opposite hold? *)
lemma 
  assumes "\<exists> shoe. \<forall> leg. fits shoe leg"
  shows "\<forall> leg. \<exists> shoe. fits shoe leg"
  using assms
  by auto

lemma 
  assumes "\<forall> leg. \<exists> shoe. fits shoe leg"
  shows "\<exists> shoe. \<forall> leg. fits shoe leg"
  using assms
  nitpick
  oops


(* In one village knights always tell the truth, and knaves always
lie. Visitor asks the person A if he is a knight, but did not
understand his answer. Person B explains that A said that he
is a knave, but then C tells that B lies. Prove that C must be
a knight. *)
lemma
  assumes "kA \<longleftrightarrow> (kA \<longleftrightarrow> saidKnightA)"
          "kB \<longleftrightarrow> \<not> saidKnightA"
          "kC \<longleftrightarrow> \<not> kB"
  shows "kC"
  using assms
  by auto

(* If everyone loves a lover and John loves Mary, then does Iago
   love Othello?
*)
lemma
  assumes "\<forall> x. (\<exists> y. loves x y) \<longrightarrow> (\<forall> z. loves z x)"
  assumes "loves John Marry"
  shows "loves Iago Othello"
  using assms
  by metis

(*
Let f be a binary operation that is associative, has a
left-identity element, and all elements have a left inverse.
Show that left inverse is always also the right inverse.
*)
lemma
  assumes 
    "\<forall> x y z. f (f x y) z = f x (f y z)"
    "\<forall> x. f a x = x"
    "\<forall> x. \<exists> y. f y x = a"
  shows "\<forall> x y. f y x = a \<longrightarrow> f x y = a"
  using assms
  by metis


(* If every element is related to at least one other element, an
the relation is symmetric and transitive, then it must also be
reflexive. *)
lemma
  assumes "\<forall> x. \<exists> y. R x y"
          "\<forall> x y z. R x y \<and> R y z \<longrightarrow> R x z"
          "\<forall> x y. R x y \<longrightarrow> R y x"
    shows "\<forall> x. R x x"
  using assms
  by metis

(* Pinocchio has at least one hat. *)
lemma 
  assumes "\<not> (\<forall> x \<in> hats. green x)"
  shows "hats \<noteq> {}"
  using assms
  by auto

(* Pinocchio has only one green hat. *)
lemma
  assumes "\<not> (\<forall> x \<in> hats. green x)"
  shows "\<exists>! x \<in> hats. green x"
  oops

(* Pinocchio has no hats. *)
lemma
  assumes "\<not> (\<forall> x \<in> hats. green x)"
  shows "hats = {}"  
  oops

(* Pinocchio has at least one green hat. *)
lemma
  assumes "\<not> (\<forall> x \<in> hats. green x)"
  shows "\<exists> x \<in> hats. green x"
  oops

(*  Pinocchio has no green hats. *)
lemma
  assumes "\<not> (\<forall> x \<in> hats. green x)"
  shows "\<forall> x \<in> hats. \<not> green x"
  oops

end