theory NaturalDeduction
imports Main
begin

lemma "A \<and> B \<longrightarrow> B \<and> A"
  apply (intro impI)
  apply (elim conjE)
  apply (intro conjI)
  apply assumption
  apply assumption 
  done


lemma "\<not> (A \<or> B) \<longrightarrow> \<not> A \<and> \<not> B"
  apply (rule impI)
  apply (rule conjI)
   apply (rule notI)
   apply (erule notE)
   apply (rule disjI1)
   apply assumption
  apply (rule notI)
  apply (erule notE)
  apply (rule disjI2)
  apply assumption
  done

lemma "\<not> (A \<and> B) \<longrightarrow> \<not> A \<or> \<not> B"
  apply (rule impI)
  apply (rule ccontr)
  apply (erule notE)
  apply (rule conjI)
   apply (rule ccontr)
   apply (erule notE)
   apply (rule disjI1)
   apply assumption
  apply (rule ccontr)
  apply (erule notE)
  apply (rule disjI2)
  apply assumption
  done

lemma "A \<or> \<not> A"
  apply (rule classical)
  apply (rule disjI1)
  apply (rule ccontr)
  apply (erule notE)
  apply (rule disjI2)
  apply assumption
  done

lemma "(\<not> A \<longrightarrow> A) \<longrightarrow> A"
  apply (rule impI)
  apply (rule ccontr)
  apply (erule impE)
   apply assumption
  apply (erule notE)
  apply assumption
  done

lemma
   "(\<forall> x. greek x \<longrightarrow> man x) \<and> 
    (\<forall> x. man x \<longrightarrow> mortal x) \<longrightarrow>
    (\<forall> x. greek x \<longrightarrow> mortal x)"
  apply (rule impI)
  apply (erule conjE)
  apply (rule allI)
  apply (rule impI)
  apply (erule_tac x="x" in allE)
  apply (erule impE)
   apply assumption
  apply (erule_tac x="x" in allE)
  apply (erule impE)
   apply assumption
  apply assumption
  done

lemma "(\<forall> x. lies x \<longrightarrow> steals x) \<and>  
       (\<exists> x. lies x) \<longrightarrow> 
       (\<exists> x. steals x)"
  apply (rule impI)
  apply (erule conjE)
  apply (erule exE)
  apply (erule_tac x="x" in allE)
  apply (erule impE)
   apply assumption
  apply (rule_tac x="x" in exI)
  apply assumption
  done

lemma "(\<forall> x. \<exists> y. R x y) \<and>
       (\<forall> x y. R x y \<longrightarrow> R y x) \<and>
       (\<forall> x y z. R x y \<and> R y z \<longrightarrow> R x z) \<longrightarrow> 
       (\<forall> x. R x x)"
  apply (rule impI)
  apply (erule conjE)+
  apply (rule allI)
  apply (erule_tac x="x" in allE)
  apply (erule exE)
  apply (erule_tac x="x" in allE)
  apply (erule_tac x="y" in allE) back
  apply (erule impE)
   apply assumption
  apply (erule_tac x="x" in allE)
  apply (erule_tac x="y" in allE)
  apply (erule_tac x="x" in allE)
  apply (erule impE)
   apply (rule conjI)
    apply assumption
   apply assumption
  apply assumption
  done

lemma "- (A \<union> B) \<subseteq> - A \<inter> - B"
  apply (rule subsetI)
  apply (rule IntI)
   apply (rule ComplI)
   apply (erule ComplE)
   apply (erule notE)
   apply (rule UnI1)
   apply assumption
  apply (rule ComplI)
  apply (erule ComplE)
  apply (erule notE)
  apply (rule UnI2)
  apply assumption
  done

end